import java.sql.*;
import java.util.*;
import javax.swing.*;
import java.text.*;
import java.io.*;

/**
 * Clase static encargada de realizar I/O sobre la base de datos
 * al estilo de DataIO pero con mayor nivel de abstraccion
 * 
 * @author G.Cherencio
 * @version 1.0
 */
public class Data {
    /**
     * Devuelve la lista de Productos
     */
    public static List<Producto> getProductos() {
        return getProductos("SELECT * FROM TBL_PRODUCTO ORDER BY DESCR ASC");
    }
    public static List<Producto> getProductos(final String query) {
        ResultSet rs = DataIO.getResultSet(query);
        List<Producto> lst = new ArrayList<Producto>();
        try {
            // cargo lista de Productos
            while(rs.next()) {
                lst.add(new Producto(rs.getInt("idp"),rs.getString("descr"),rs.getDouble("precio_base"),rs.getInt("stock")));
            }
            rs.close();
        } catch(SQLException sqle) {
            System.err.println("Data.getProductos(): Error "+sqle.getMessage());
        }
        return lst;
    }
    /**
     * Devuelve la lista de Clientes
     */
    public static List<Cliente> getClientes() {
        return getClientes("SELECT * FROM TBL_CLIENTE ORDER BY DESCR ASC");
    }
    public static List<Cliente> getClientes(final String query) {
        ResultSet rs = DataIO.getResultSet(query);
        List<Cliente> lstc = new ArrayList<Cliente>();
        try {
            // cargo lista de Clientes
            while(rs.next()) {
                lstc.add(new Cliente(rs.getInt("idc"),rs.getString("descr"),rs.getDouble("saldo")));
            }
            rs.close();
        } catch(SQLException sqle) {
            System.err.println("ProductoComboModel(): Error "+sqle.getMessage());
        }
        return lstc;
    }
    
    
}
