
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;
import java.sql.*;
import java.util.*;
/**
 * Combo Model Generico para cualquier tipo de objeto
 * 
 * @author G. Cherencio
 * @version 1.0
 */
public class MyComboModel<E> extends DefaultComboBoxModel<E> {
    private List<E> lst = new ArrayList<E>();
    private Object selected = null;
    
    /**
     * Constructor for objects of class MyComboModel
     */
    public MyComboModel(List<E> l) {
        lst=l;
    }
    // IMPLEMENTO INTERFASE MutableComboBoxModel
    public void setSelectedItem(Object anItem) {
        selected = anItem;
        if ( anItem != null ) {
            int pos = lst.indexOf(anItem);
            if ( pos != -1 ) selected = lst.get(pos);
            else selected = null;
        }
        super.setSelectedItem(selected);
    }
    public Object getSelectedItem() { return selected; }
    public void addElement(E item) { 
        lst.add(item);
        int pos = lst.indexOf(item);
        fireContentsChanged(this, 0, lst.size());
        //fireIntervalAdded(this,pos,pos+1);
    }
    public void removeElement(Object obj) { 
        int pos = lst.indexOf(obj);
        lst.remove(obj); 
        fireContentsChanged(this, 0, lst.size());
        //fireIntervalRemoved(this,pos,pos+1);
    }
    public void insertElementAt(E item,int index) { 
        lst.add(index,item); 
        fireContentsChanged(this, 0, lst.size());
        //fireIntervalAdded(this,index,index+1);
    }
    public void removeElementAt(int index) { 
        lst.remove(index); 
        fireContentsChanged(this, 0, lst.size());
        //fireIntervalRemoved(this,index,index+1);
    }

    // IMPLEMENTO INTERFASE ListModel
    public void addListDataListener(ListDataListener l) {
    }
    public E getElementAt(int index)    { return lst.get(index);}
    public int getSize()                { return lst.size();    }
    public void removeListDataListener(ListDataListener l) {}
    
    // CUSTOM METHODS
    public void setList(List<E> l) {
        fireIntervalRemoved(this,0,lst.size());
        lst = l;
        if ( selected != null ) {
            if ( !lst.contains(selected) ) {
                selected = null;
                setSelectedItem(selected);
            }
        }
        fireIntervalAdded(this,0,lst.size());
    }
    public List<E> getList()       { return lst; }

} 